package fr.graphit.bootstrap;

import java.util.List;

/** BootstrapService defines a set of method used at application startup to load required data.
 * @author Thomas Clarisse
 */
public interface BootstrapService {

    /** Checks that the schema in database is created and consistent.
     * @throws RuntimeException
     */
	public void schemaConsistencyCheck() throws RuntimeException;

    /**
     * Check if a set of properties is well loaded
     * @param properties Set of properties to check
     * @throws RuntimeException
     */
	public void propertiesCheck(List<String> properties) throws RuntimeException;

    /**
     * Check if the type definition and properties definition are loaded
     * @throws RuntimeException
     */
	public void modelCheck() throws RuntimeException;
	
}
