package fr.graphit.core.api.model;

import java.util.ArrayList;
import java.util.List;

import com.google.inject.Inject;

import fr.graphit.core.api.NodesService;
import fr.graphit.core.api.exception.model.ViewNotFoundException;
import fr.graphit.core.api.exception.node.UnableToRetrieveNodesException;

public class View {

	private Integer id;
	private String name;
	private List<Node> nodes;
	
	private NodesService nodesService;
	
	@Inject
	public View(NodesService nodesService) {
		this.nodesService = nodesService;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List<Node> nodes() {
		
		if(nodes == null) {
		
			try {
				return nodesService.searchNodesByView(this);
			}
			catch (UnableToRetrieveNodesException e) {
				return new ArrayList<Node>();
			}
			catch (ViewNotFoundException e) {
				return new ArrayList<Node>();
			}
		}
		
		return nodes;
	}

	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof View) {
			View itemObj = (View) obj;
			return itemObj.getId().equals(this.id);
		}
		return false;
	}

}
