package fr.graphit.core.database;

import java.sql.Connection;
import java.sql.SQLException;

import org.apache.commons.lang.exception.ExceptionUtils;
import org.apache.log4j.Logger;

import fr.graphit.core.api.exception.database.DatabaseException;

public class DatabaseHelper {

	private static final Logger logger = Logger.getLogger(DatabaseHelper.class);
	
	public void closeConnection(Connection connection) throws DatabaseException {
		try {
			// checking connection status
			if(connection != null && !connection.isClosed()) {
				// performing a rollback to cancel all not commited modification
				connection.rollback();
				// closing connection
				connection.close();
			}
		}
		catch(SQLException e) {
			if(logger.isDebugEnabled()) {
				logger.debug(ExceptionUtils.getStackTrace(e));
			}
			logger.error(DatabaseErrorMessages.UNABLE_TO_CLOSE);
			throw new DatabaseException(DatabaseErrorMessages.UNABLE_TO_CLOSE, e);
		}
	}
	
}
