package fr.graphit.web.api.graph;

import java.util.List;

import com.google.inject.Injector;

import fr.graphit.core.api.model.Node;
import fr.graphit.web.exception.GraphException;

public abstract class GraphBuilder {
	
	public abstract GraphBuilder providedBy(String provider);
	
	public abstract GraphBuilder renderedBy(String engine);
	
	public abstract String asSVG(Injector injector, String urlCallback) throws GraphException;
	
	public abstract byte[] asPNG(Injector injector) throws GraphException;
	
	static public GraphBuilder graph(List<Node> nodes) {
		return new GraphBuilderMaker(nodes);
	}

}
