package fr.graphit.web.api.graph.provider.google;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.apache.http.HttpHost;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.conn.params.ConnRoutePNames;
import org.apache.http.impl.client.DefaultHttpClient;


public abstract class GoogleChartClient {

	protected DefaultHttpClient client;
	protected String cht;
	protected String chl;
	
	public abstract JsonGoogleGraphFormat json() throws UnsupportedEncodingException, ClientProtocolException, IOException;
	
	public abstract byte[] png() throws UnsupportedEncodingException, ClientProtocolException, IOException;
	
	public static GoogleChartClient init(String cht, String chl) {
		
		DefaultHttpClient client = new DefaultHttpClient();
		
		String proxyHost = System.getProperty("https.proxyHost");
		if(proxyHost == null) {
			proxyHost = System.getProperty("http.proxyHost");
		}
		
		if(proxyHost != null) {
			
			String proxyUser = System.getProperty("https.proxyUser");
			if(proxyUser == null) {
				proxyUser = System.getProperty("http.proxyUser");
			}
			
			String proxyPassword = System.getProperty("https.proxyPassword");
			if(proxyPassword == null) {
				proxyPassword = System.getProperty("http.proxyPassword");
			}
			
			if(proxyUser != null && proxyPassword != null) {
				client.getCredentialsProvider().setCredentials(
	                    new AuthScope("localhost", 8080), // TODO : what is this ?
	                    new UsernamePasswordCredentials(proxyUser, proxyPassword));
			}
			
			String proxyPort = System.getProperty("https.proxyPort");
			if(proxyPort == null) {
				proxyPort = System.getProperty("http.proxyPort");
			}
			if(proxyPort == null) {
				proxyPort = "80";
			}
			
			HttpHost proxy = new HttpHost(proxyHost, Integer.parseInt(proxyPort));
            
            client.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, proxy);
		}
		
	    return new GoogleChartClientMaker(client, cht, chl);
	  }
	
}
