package fr.graphit.web.api.graph.provider.google;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpHost;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;


public class GoogleChartClientMaker extends GoogleChartClient {

	public GoogleChartClientMaker(DefaultHttpClient client, String cht, String chl) {
		this.client = client;
		this.chl = chl;
		this.cht = cht;
	}

	@Override
	public JsonGoogleGraphFormat json() throws UnsupportedEncodingException, ClientProtocolException, IOException {
		
		HttpHost targetHost = new HttpHost("chart.googleapis.com", 443, "https");
		HttpPost post = new HttpPost("/chart");
		
		List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
		nameValuePairs.add(new BasicNameValuePair("cht", cht));
		nameValuePairs.add(new BasicNameValuePair("chl", chl));
		nameValuePairs.add(new BasicNameValuePair("chof", "json"));
		post.setEntity(new UrlEncodedFormEntity(nameValuePairs));
		
		ResponseHandler<JsonGoogleGraphFormat> responseHandler = new JsonResponseHandler<JsonGoogleGraphFormat>(JsonGoogleGraphFormat.class);
		return client.execute(targetHost, post, responseHandler);
		
	}

	@Override
	public byte[] png() throws UnsupportedEncodingException, ClientProtocolException, IOException {
		HttpHost targetHost = new HttpHost("chart.googleapis.com", 443, "https");
		HttpPost post = new HttpPost("/chart");
		
		List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
		nameValuePairs.add(new BasicNameValuePair("cht", cht));
		nameValuePairs.add(new BasicNameValuePair("chl", chl));
		nameValuePairs.add(new BasicNameValuePair("chof", "png"));
		post.setEntity(new UrlEncodedFormEntity(nameValuePairs));
		
		ResponseHandler<byte[]> responseHandler = new ByteArrayResponseHandler();
		return client.execute(targetHost, post, responseHandler);
	}

}
