package fr.graphit.web.api.reply.transport;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.io.IOUtils;

import com.google.sitebricks.client.Transport;

public class PNG implements Transport {

  public String contentType() {
    return "image/png";
  }
  
  @SuppressWarnings("unchecked")
  public <T> T in(InputStream in, Class<T> type) throws IOException {
    assert type == byte[].class;
    return (T) IOUtils.toByteArray(in);
  }

  public <T> void out(OutputStream out, Class<T> type, T data) throws IOException {
    assert data instanceof byte[];
    out.write((byte[]) data);
  }
  
}
