package fr.graphit.web.client;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.inject.Injector;

import fr.graphit.core.api.ModelService;
import fr.graphit.core.api.NodesService;
import fr.graphit.web.client.template.TemplateEngine;
import fr.graphit.web.messages.UIMessages;
import fr.graphit.web.session.SessionHandler;

public abstract class AbstractService {
	
	protected TemplateEngine templateEngine;
	protected NodesService nodes;
	protected ModelService model;
	protected SessionHandler session;
	protected UIMessages messages;
	protected Injector injector;
	
	public AbstractService(Injector injector, UIMessages messages, TemplateEngine templateEngine, NodesService nodes, ModelService model, SessionHandler session) {
		this.templateEngine = templateEngine;
		this.nodes = nodes;
		this.model = model;
		this.session = session;
		this.messages = messages;
		this.injector = injector;
	}
	
	protected List<String> errors = new ArrayList<String>();
	
	protected Map<String, Object> initModel() {
		Map<String, Object> model = new HashMap<String, Object>();
		model.put("messages", messages);
		model.put("errors", errors);
		model.put("isAdmin", session.isAdmin);
		if(session.isAdmin) {
			model.put("user", session.currentUser);
		}
		return model;
	}
	
}