package fr.graphit.web.client;

import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.Key;
import com.google.inject.name.Names;
import com.google.sitebricks.headless.Reply;
import com.google.sitebricks.http.Get;
import com.google.sitebricks.http.Post;

import fr.graphit.core.api.ModelService;
import fr.graphit.core.api.NodesService;
import fr.graphit.web.client.template.TemplateEngine;
import fr.graphit.web.messages.UIMessages;
import fr.graphit.web.session.SessionHandler;
import fr.graphit.web.uri.URIContext;

public class ConnectAndDisconnectService extends AbstractService {
	
	private String login;
	private String password;
	
	@Inject
	public ConnectAndDisconnectService(Injector injector, UIMessages messages, TemplateEngine templateEngine, NodesService nodes, ModelService model, SessionHandler session) {
		super(injector, messages, templateEngine, nodes, model, session);
	}
	
	@Get
	public Reply<?> get() {
		session.isAdmin = false;
		return Reply.saying().redirect(URIContext.VIEWS);
	}
	
	@Post
	public Reply<?> post() {

        String targetLogin = injector.getInstance(Key.get(String.class, Names.named("admin.login")));
        String targetPassword = injector.getInstance(Key.get(String.class, Names.named("admin.password")));

		if(login.equals(targetLogin) && password.equals(targetPassword)) {
			session.isAdmin = true;
		}
		
		return Reply.saying().redirect(URIContext.SEARCH);
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

}
