package fr.graphit.web.filter;

import java.io.IOException;
import java.sql.Timestamp;
import java.util.Date;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.inject.Inject;

import fr.graphit.web.messages.UIMessages;
import fr.graphit.web.uri.URIContext;

public class BrowserFilter implements Filter {

	private UIMessages messages;
	
	@Inject
	public BrowserFilter(UIMessages messages) {
		this.messages = messages;
	}
	
	@Override
	public void destroy() {}

	@Override
	public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException {
		
		String userAgent = ((HttpServletRequest)req).getHeader("User-Agent");
		if (userAgent.contains("Chrome") || userAgent.contains("Firefox")) {
			chain.doFilter(req, resp);
			return;
		}
		
		Date date= new Date();
		Timestamp t = new Timestamp(date.getTime());
		
		((HttpServletResponse) resp).sendRedirect(URIContext.BAD_BROWSER + "?t="+t.toString());

	}

	@Override
	public void init(FilterConfig arg0) throws ServletException {}

}
