package fr.graphit.web.filter;

import org.apache.log4j.Logger;

import com.google.inject.Singleton;
import com.google.sitebricks.SitebricksServletModule;

public class FilterModule extends SitebricksServletModule {

	private static final Logger logger = Logger.getLogger(FilterModule.class);
	
	@Override
	protected void configurePreFilters() {
		
		logger.info("Starting Graphit Filter Module...");
		
		bind(BrowserFilter.class).in(Singleton.class);
		bind(SecurityFilter.class).in(Singleton.class);
		
		filter("/*").through(BrowserFilter.class);
		filter("/admin/*").through(SecurityFilter.class);
		
		logger.info("Graphit Filter Module is started.");
		
	}

}
