package fr.graphit.web.filter;

import java.io.IOException;
import java.sql.Timestamp;
import java.util.Date;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletResponse;

import com.google.inject.Inject;
import com.google.inject.Injector;

import fr.graphit.web.messages.UIMessages;
import fr.graphit.web.session.SessionHandler;
import fr.graphit.web.uri.URIContext;

public class SecurityFilter implements Filter {

	private UIMessages messages;
	private Injector injector;
	
	@Inject
	public SecurityFilter(UIMessages messages, Injector injector) {
		this.messages = messages;
		this.injector = injector;
	}
	
	@Override
	public void destroy() {}

	@Override
	public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException {
		
		Date date= new Date();
		Timestamp t = new Timestamp(date.getTime());
		
		if(injector.getInstance(SessionHandler.class).isAdmin == false) {
			((HttpServletResponse) resp).sendRedirect(URIContext.VIEWS + "?t="+t.toString());
		}
		
		chain.doFilter(req, resp);

	}

	@Override
	public void init(FilterConfig arg0) throws ServletException {}

}
