package fr.graphit.web.session;

import fr.graphit.core.api.model.Node;
import fr.graphit.core.api.model.View;

import java.io.Serializable;

/**
 * Object stored in session scoped.
 * @author Thomas Clarisse
 *
 */
public class SessionHandler implements Serializable {

	/**
	 * The last opened item is stored in session
	 */
	public Node currentNode;
	
	/**
	 * This property is set to true when the current user is logged
	 */
	public Boolean isAdmin = false;
	
	/**
	 * this property is the name of the current user
	 */
	public String currentUser;
	
	/**
	 * The last opened subgraph is stored in session
	 */
	public View currentView;
	
	
}