(function($) {

var methods = {
		
	init : function(options) {
		
		return this.each(function() {
			
			 var settings = {
				'url_prefix' : '',
				'id_node' : -1,
				'exclude_children' : false,
				'exclude_parents' : false,
				'callback' : null, 
				'error' : null
			};
			 
			 if (options) {
				$.extend(settings, options);
			}
			 
			 $(this).autocomplete({
					source : function(request, response) {
						
						GraphitAPI.search(request.term, settings.url_prefix,
								
							function(candidates) {
							
								var searchIn = function(id, nodes) {
									for(var i = 0; i < nodes.length; i++) {
										if(nodes[i].id == id) {
											return i;
										}
									}
									return -1;
								};
							
								var handler = function(parents, children) {
									var autocompletes = [];
									
									for(var i = 0; i < candidates.length; i++) {
										if(settings.id_node > -1 && parents.length > 0 && settings.exclude_parents && searchIn(candidates[i].id, parents) > -1) {
											continue;
										}
										if(settings.id_node > -1 && children.length > 0 && settings.exclude_children && searchIn(candidates[i].id, children) > -1) {
											continue;
										}
										if(settings.id_node > -1 && candidates[i].id == settings.id_node) {
											continue;
										}
										autocompletes.push({
											'id' : candidates[i].id, 
											'label' : candidates[i].name,
											'value' : candidates[i].name
										});
									}
									response(autocompletes);
								};
								
								if(settings.id_node > -1) {
									GraphitAPI.getLinks(settings.id_node, settings.url_prefix, 
										function(links) {
											handler(links.parents, links.children);
										}, 
										function() {
											handler([], []);
										}
									);
								}
								else {
									handler([], []);
								}
								
							}, settings.error
				   		);
						
					},
					open : function(e, ui) {
						var autoCompleteData = $(this).data('autocomplete');
						autoCompleteData.menu.element
							.find('a')
							.each(function() {
								var me = $(this);
								var regex = new RegExp(autoCompleteData.term, "gi");
								me.html(me.text().replace(regex,function(matched) {
									return '<span class="autocomplete-term">%s</span>'.replace('%s',matched);
								}));
							});
					},
					minLength : 2,
					cache : false,
					select : settings.callback
				});
			
		});
		
	}
};

$.fn.itemsAutocomplete = function(method) {
    
	if (methods[method]) {
		return methods[method].apply(this, Array.prototype.slice.call(arguments,1));
	}
	else if(typeof method === 'object' || ! method ) {
		return methods.init.apply(this, arguments );
	}  
  
};

})(jQuery);