var GraphitAPI = {
	
	getNode : function(id_node, url_prefix, success, error) {
			
			var params = {
				'node_id' : id_node,
				'format' : 'json'
			};
			
			var xhr = $.post(url_prefix + "/admin/api/node", params, function(data) {
				if(data.success) {
					success(data.success);
				}
				else if(data.error) {
					error(data.error);
				}
			}, 'json');
			
			xhr.error(function(jqxhr) {
				 if(jqxhr.status != 0) {
					 error(jqxhr.statusText);
				 }
			});
			
			return xhr;
			
		},
		
		deleteNode : function(id_node, url_prefix, success, error) {
			
			var params = {
				'node_id' : id_node,
				'format' : 'json'
			};
			
			var xhr = $.post(url_prefix + "/admin/api/delete", params, function(data) {
				if(data.success) {
					success(data.success);
				}
				else if(data.error) {
					error(data.error);
				}
			}, 'json');
			
			xhr.error(function(jqxhr) {
				 if(jqxhr.status != 0) {
					 error(jqxhr.statusText);
				 }
			});
			
			return xhr;
			
		},
		
		addNodeToView : function(id_node, id_view, url_prefix, success, error) {
			
			var params = {
				'id_view' : id_view,
				'id_node' : id_node,
				'format' : 'json'
			};
			
			var xhr = $.post(url_prefix + "/admin/api/addNodeView", params, function(data) {
				if(data.success) {
					success(data.success);
				}
				else if(data.error) {
					error(data.error);
				}
			}, 'json');
			
			xhr.error(function(jqxhr) {
				 if(jqxhr.status != 0) {
					 error(jqxhr.statusText);
				 }
			});
			
			return xhr;
			
		},
		
		deleteNodeFromView : function(id_node, id_view, url_prefix, success, error) {
			
			var params = {
				'id_view' : id_view,
				'id_node' : id_node,
				'format' : 'json'
			};
			
			var xhr = $.post(url_prefix + "/admin/api/deleteNodeView", params, function(data) {
				if(data.success) {
					success(data.success);
				}
				else if(data.error) {
					error(data.error);
				}
			}, 'json');
			
			xhr.error(function(jqxhr) {
				 if(jqxhr.status != 0) {
					 error(jqxhr.statusText);
				 }
			});
			
			return xhr;
			
		},
		
		deleteView : function(id_view, url_prefix, success, error) {
			
			var params = {
				'view_id' : id_view,
				'format' : 'json'
			};
			
			var xhr = $.post(url_prefix + "/admin/api/deleteView", params, function(data) {
				if(data.success) {
					success(data.success);
				}
				else if(data.error) {
					error(data.error);
				}
			}, 'json');
			
			xhr.error(function(jqxhr) {
				 if(jqxhr.status != 0) {
					 error(jqxhr.statusText);
				 }
			});
			
			return xhr;
			
		},
		
	addLink : function(id_parent, id_child, url_prefix, success, error) {
		
		var params = {
			'id_parent' : id_parent,
			'id_child' : id_child,
			'format' : 'json'
		};
		
		var xhr = $.post(url_prefix + "/admin/api/addLink", params, function(data) {
			if(data.success) {
				success(data.success);
			}
			else if(data.error) {
				error(data.error);
			}
		}, 'json');
		
		xhr.error(function(jqxhr) {
			 if(jqxhr.status != 0) {
				 error(jqxhr.statusText);
			 }
		});
		
		return xhr;
		
	},
	
	deleteLink : function(id_parent, id_child, url_prefix, success, error) {
		
		var params = {
			'id_parent' : id_parent,
			'id_child' : id_child,
			'format' : 'json'
		};
		
		var xhr = $.post(url_prefix + "/admin/api/deleteLink", params, function(data) {
			if(data.success) {
				success(data.success);
			}
			else if(data.error) {
				error(data.error);
			}
		}, 'json');
		
		xhr.error(function(jqxhr) {
			 if(jqxhr.status != 0) {
				 error(jqxhr.statusText);
			 }
		});
		
		return xhr;
		
	},
	
	getLinks : function(id_item, url_prefix, success, error) {
		var params = {
			'id_item' : id_item,
			'format' : 'json'
		};
		
		var xhr = $.post(url_prefix + "/admin/api/getLinks", params, function(data) {
			if(data.success) {
				success(data.success);
			}
			else if(data.error) {
				error(data.error);
			}
		}, 'json');
		
		xhr.error(function(jqxhr) {
			 if(jqxhr.status != 0) {
				 error(jqxhr.statusText);
			 }
		});
		
		return xhr;
	},
	
	search : function(search_term, url_prefix, success, error) {
		
		var params = {
			'search_term' : search_term,
			'format' : 'json'
		};
		
		var xhr = $.post(url_prefix + "/admin/api/search", params, function(data) {
			if(data.success) {
				success(data.success);
			}
			else if(data.error) {
				error(data.error);
			}
		}, 'json');
		
		xhr.error(function(jqxhr) {
			 if(jqxhr.status != 0) {
				 error(jqxhr.statusText);
			 }
		});
		
		return xhr;
		
	},
	
	graph : function(provider, engine, id_center, id_subgraph, parents_level, children_level, format, url_prefix, success, error) {
		
		var params = {
			'id_center' : id_center,
			'id_subgraph' : id_subgraph,
			'parents_level' : parents_level,
			'children_level' : children_level,
			'format' : format,
			'provider' : (provider==null?'native':provider),
			'engine' : (engine==null?'dot':engine)
		};
		
		var xhr = $.post(url_prefix + "/api/graph", params, function(data) {
			if(params.format == 'json') {
				if(data.success) {
					success(data.success);
				}
				else if(data.error) {
					error(data.error);
				}
			}
			else {
				success(data);
			}
		});
		
		xhr.error(function(jqxhr) {
			 if(jqxhr.status != 0) {
				 error(jqxhr.statusText);
			 }
		});
		
		return xhr;
		
	}
		
};
