(function($) {
	
	var methods = {
		init : function( options ) {
			
			return this.each(function() {
				
	            var data = $(this).data('upAndDown');
	            
	            if(!data) {
				
	            	var settings = {
	    				'initialValue' : 1,
	    				'imgUp' : '',
	    				'imgDown' : '',
	    				'callback' : function() {}
	    			};
	    			
	    			if (options) {
	    				$.extend(settings, options);
	    			}
	            	
	    			var ul = $('<ul>').addClass('upAndDownList').appendTo(this);
	            	var upVar = $('<li>').append($('<img>').attr('alt','up').attr('src', settings.imgUp)).appendTo(ul);
	            	var labelVar = $('<li>').addClass('upAndDownLabel').append($('<span>').text(settings.initialValue)).appendTo(ul);
	    			var downVar = $('<li>').append($('<img>').attr('alt','down').attr('src', settings.imgDown)).appendTo(ul);
	    			
	    			upVar.click(function() {
	    				var currentValue = parseInt(labelVar.text());
	    				labelVar.text(currentValue+1);
	    				settings.callback();
	    			});
	    			
	    			downVar.click(function() {
	    				var currentValue = parseInt(labelVar.text());
	    				if(currentValue > 0) {
		    				labelVar.text(currentValue-1);
		    				settings.callback();
	    				}
	    			});
	    			
	    			$(this).data('upAndDown', {
				        target : $(this),
				        label : labelVar,
				        up : upVar,
				        down : downVar
				    });
				}
	            
			});
	
		},
		
		val : function() {
			return parseInt($(this).data('upAndDown').label.text());
		}
		
	};
	
	$.fn.upAndDown = function(method) {
	    
		if (methods[method]) {
			return methods[method].apply(this, Array.prototype.slice.call(arguments,1));
		}
		else if(typeof method === 'object' || ! method ) {
			return methods.init.apply(this, arguments );
		}  
	  
	};
	
})(jQuery);
